
#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class Api::V1::ClusterController < Api::V1::BaseController
  ## ======================================================================
  # => Before and after actions
  ## ======================================================================
  skip_before_action :authenticate_user_from_token!, :cdomain, raise: false

  # ----------------------------------------------
  # Actions
  # ----------------------------------------------

  def index
    @managers = Manager.all.sort_by(&:name)
    render json: @managers
  end

  # GET /cdomain
  def cdomain
    result_json = { cdomain: Redborder::Cluster.cdomain }

    render json: result_json
  rescue StandardError
    error_500('There is an error trying to obtain this information.')
  end

  private

  def require_super_administrative_privileges_manager
    return true if user_signed_in? && current_user.super_admin?
    # Check if request comes from a widget
    if params['w'] == 'true'
      render template: 'managers/no_privileges', layout: false, status: 403
    else
      no_enough_privileges
    end
  end

  def require_super_reader_privileges_manager
    return true if user_signed_in? && current_user.super_reader?
    # Check if request comes from a widget
    if params['w'] == 'true'
      render template: 'managers/no_privileges', layout: false, status: 403
    else
      no_enough_privileges
    end
  end
end
