#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################


class Api::V1::JobsController < Api::V1::BaseController
  # ----------------------------------------------
  # Before and after actions
  # ----------------------------------------------
  before_action :authenticate_user_from_token!, :user_setup_api, raise: false

  # ----------------------------------------------
  
  respond_to :html
  respond_to :js, :json, only: [
    :index, :destroy, :destroy_stored_job, :info
  ]

  def index
    @node_name = "#{`hostname`.delete("\n")}"

    if current_user.super_admin? || current_user.super_reader?
      @jobs = DelayedJob.all
      @workers = DelayedJob.process
    else
      @jobs = DelayedJob.all.select { |dj| dj.user_id.equal? current_user.id }
    end
    render json: {
      jobs: @jobs,
      workers: @workers,
    }
  end
end